Description

It might be useful to request avatar image in one size big enough to display at the profile page. Other sizes could be produced by

rescaling the big one to any size we want by just a CSS rule.

This helps reduce load to the gravatar servers, reduce total HTTP request needed to render the page, reduces reflows caused by

image been getting its real size on load, and last but not least theme designers get control over the avatar size without intrusion to

the server side.

History

#1 - 2012-07-26 13:35 - Peter Leonov

An addition. We could select the most popular avatar size by default to hit a browser cache if the browser has already met this avatar on the other

site.

#2 - 2012-07-27 21:00 - Jean-Philippe Lang

I don't know if it's a good idea, most browsers have low-quality algorithms for resampling images (eg. nearest) right?

#3 - 2012-07-27 21:20 - Peter Leonov

AFAIK, the only browser which ever used nearest-neighbor algorithm is MSIE. And MSIE versions 7.0 and 8.0 have a simple CSS tweak to switch to

an eye candy bicubic interpolation. As far as MSIE 9.0 uses hardware acceleration by default it just can't scale otherwise than using a bicubic scaling.

In my experience, other browsers support smooth rescaling for years.

WebKit-based browsers may use nearest on images with heavy animated size. For static images it uses bicubic as expected.

#4 - 2012-07-27 22:12 - Jean-Philippe Lang

- File resampling.png added

Just made a quick test with Firefox 14.

On the left, a bicubic resample of a screenshot. On the right, the same screenshot resampled by FF:

 

Doesn't seem to be the same bicubic resampling.

#5 - 2012-07-27 22:28 - Jean-Philippe Lang

On small images, the difference is not so obvious (but still visible with my FF).
An original 20x20 gravatar on the left, a 60x60 gravatar resampled at 20x20 by [your browser]:

 8fe1970d5ccdd67ce0eef376cb3c786b?rating=PG&amp;size=20  8fe1970d5ccdd67ce0eef376cb3c786b?rating=PG&amp;size=60 

#6 - 2012-07-27 22:33 - Peter Leonov

- File MSIE 8.png added

- File Chrome Win.png added

- File Firefox Win.png added

- File Firefox Mac.png added

- File Opera Mac.png added

- File Safari Mac.png added

Yeap, you'r right for Firefox (Win) and Opera (Win and Mac) with large images. But for sane avatar sizes all go bicubic way.

Here is a set of screenshots of my gravatar scaled from 300px on the left, and 1300px on the right for different browsers on Mac and Win.

Use this code:

<style>

.ava { width: 150px; }

</style>

<img class="ava" src="http://www.gravatar.com/avatar/3ba04ac580b453fa6cc4457500d032c6?rating=PG&size=300&defau

lt="/>

<img class="ava" src="http://www.gravatar.com/avatar/3ba04ac580b453fa6cc4457500d032c6?rating=PG&size=1300&defa

ult="/>

#7 - 2012-07-27 22:38 - Peter Leonov

Jean-Philippe Lang wrote:

On small images, the difference is not so obvious (but still visible with my FF).

 Yes, indeed! Glad to see you investigating client side quirks ;)

#8 - 2012-07-27 22:43 - Jean-Philippe Lang

Plus, the original 20x20 gravatar is 1.06 KB, the 60x60 is 3.04 KB.

#9 - 2012-07-27 23:09 - Jean-Philippe Lang

FWIW, Github uses only one gravatar size (140x140).

#10 - 2014-07-04 04:26 - Go MAEDA

+1

If this feature is implemented, Gravatar icons on Redmine become Retina Ready.

#11 - 2014-08-02 16:05 - Toshi MARUYAMA

- Category set to UI

Files

resampling.png 21.1 KB 2012-07-27 Jean-Philippe Lang
Safari Mac.png 84.1 KB 2012-07-27 Peter Leonov
